searchData={"items":[{"type":"module","title":"EctoTrailChangeEnum","doc":"","ref":"EctoTrailChangeEnum.html"},{"type":"function","title":"EctoTrailChangeEnum.cast/1","doc":"Callback implementation for  Ecto.Type.cast/1 .","ref":"EctoTrailChangeEnum.html#cast/1"},{"type":"function","title":"EctoTrailChangeEnum.create_type/0","doc":"","ref":"EctoTrailChangeEnum.html#create_type/0"},{"type":"function","title":"EctoTrailChangeEnum.drop_type/0","doc":"","ref":"EctoTrailChangeEnum.html#drop_type/0"},{"type":"function","title":"EctoTrailChangeEnum.dump/1","doc":"Callback implementation for  Ecto.Type.dump/1 .","ref":"EctoTrailChangeEnum.html#dump/1"},{"type":"function","title":"EctoTrailChangeEnum.embed_as/1","doc":"Callback implementation for  Ecto.Type.embed_as/1 .","ref":"EctoTrailChangeEnum.html#embed_as/1"},{"type":"function","title":"EctoTrailChangeEnum.equal?/2","doc":"Callback implementation for  Ecto.Type.equal?/2 .","ref":"EctoTrailChangeEnum.html#equal?/2"},{"type":"function","title":"EctoTrailChangeEnum.load/1","doc":"Callback implementation for  Ecto.Type.load/1 .","ref":"EctoTrailChangeEnum.html#load/1"},{"type":"function","title":"EctoTrailChangeEnum.schema/0","doc":"","ref":"EctoTrailChangeEnum.html#schema/0"},{"type":"function","title":"EctoTrailChangeEnum.schemaless_type/0","doc":"","ref":"EctoTrailChangeEnum.html#schemaless_type/0"},{"type":"type","title":"EctoTrailChangeEnum.t/0","doc":"","ref":"EctoTrailChangeEnum.html#t:t/0"},{"type":"function","title":"EctoTrailChangeEnum.type/0","doc":"Callback implementation for  Ecto.Type.type/0 .","ref":"EctoTrailChangeEnum.html#type/0"},{"type":"function","title":"EctoTrailChangeEnum.valid_value?/1","doc":"","ref":"EctoTrailChangeEnum.html#valid_value?/1"},{"type":"module","title":"EctoTrailer","doc":"EctoTrailer allows to store changeset changes into a separate `audit_log` table.","ref":"EctoTrailer.html"},{"type":"module","title":"Usage - EctoTrailer","doc":"1. Add `ecto_trailer` to your list of dependencies in `mix.exs`:\n\n    def deps do\n      [{:ecto_trailer, \"~> 0.1.0\"}]\n    end\n\n2. Add a migration that creates `audit_log` table to `priv/repo/migrations` folder:\n\n    defmodule EctoTrailer.TestRepo.Migrations.CreateAuditLogTable do\n      @moduledoc false\n      use Ecto.Migration\n\n      def change do\n        create table(:audit_log, primary_key: false) do\n          add :id, :uuid, primary_key: true\n          add :actor_id, :string, null: false\n          add :resource, :string, null: false\n          add :resource_id, :string, null: false\n          add :changeset, :map, null: false\n\n          timestamps([type: :utc_datetime, updated_at: false])\n        end\n      end\n    end\n\n4. Use `EctoTrailer` in your repo:\n\n    defmodule MyApp.Repo do\n      use Ecto.Repo, otp_app: :my_app\n      use EctoTrailer\n    end\n\n5. Use logging functions instead of defaults. See `EctoTrailer` module docs.","ref":"EctoTrailer.html#module-usage"},{"type":"type","title":"EctoTrailer.action_type/0","doc":"","ref":"EctoTrailer.html#t:action_type/0"},{"type":"function","title":"EctoTrailer.delete_and_log/4","doc":"Call `c:Ecto.Repo.delete/2` operation and store deleted objext in a `change_log` table.","ref":"EctoTrailer.html#delete_and_log/4"},{"type":"function","title":"EctoTrailer.insert_and_log/4","doc":"Call `c:Ecto.Repo.insert/2` operation and store changes in a `change_log` table.\n\nInsert arguments, return and options same as `c:Ecto.Repo.insert/2` has.","ref":"EctoTrailer.html#insert_and_log/4"},{"type":"function","title":"EctoTrailer.log/5","doc":"Store changes in a `change_log` table.","ref":"EctoTrailer.html#log/5"},{"type":"function","title":"EctoTrailer.log_bulk/5","doc":"Store bulk changes in a `change_log` table.","ref":"EctoTrailer.html#log_bulk/5"},{"type":"function","title":"EctoTrailer.update_and_log/4","doc":"Call `c:Ecto.Repo.update/2` operation and store changes in a `change_log` table.\n\nInsert arguments, return and options same as `c:Ecto.Repo.update/2` has.","ref":"EctoTrailer.html#update_and_log/4"},{"type":"function","title":"EctoTrailer.upsert_and_log/4","doc":"Call `c:Ecto.Repo.upsert/2` operation and store changes in a `change_log` table.\n\nInsert arguments, return and options same as `c:Ecto.Repo.upsert/2` has.","ref":"EctoTrailer.html#upsert_and_log/4"},{"type":"module","title":"EctoTrailer.Changelog","doc":"This is schema that used to store changes in DB.","ref":"EctoTrailer.Changelog.html"},{"type":"extras","title":"EctoTrailer","doc":"# EctoTrailer\n\n[![CI](https://github.com/maxohq/ecto_trailer/actions/workflows/ci.yml/badge.svg?style=flat)](https://github.com/maxohq/ecto_trailer/actions/workflows/ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/ecto_trailer.svg?style=flat)](https://hex.pm/packages/ecto_trailer)\n[![Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg?style=flat)](https://hexdocs.pm/ecto_trailer)\n[![Total Download](https://img.shields.io/hexpm/dt/ecto_trailer.svg?style=flat)](https://hex.pm/packages/ecto_trailer)\n[![License](https://img.shields.io/hexpm/l/ecto_trailer.svg?style=flat)](https://github.com/maxohq/ecto_trailer/blob/main/LICENCE)\n\n\n- Fork from https://github.com/valiot/ecto_trail -> https://github.com/Nebo15/ecto_trail\n- renamed, so we can release an updated package on Hex.pm\n\nEctoTrailer allows to store changeset changes into a separate `audit_log` table.","ref":"readme.html"},{"type":"extras","title":"Installation and usage - EctoTrailer","doc":"1. Add `ecto_trailer` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [{:ecto_trailer, \"~> 1.0\"}]\nend\n```\n\n\n2. Add a migration that creates `audit_log` table to `priv/repo/migrations` folder:\n\n```elixir\ndefmodule EctoTrailer.TestRepo.Migrations.CreateAuditLogTable do\n  @moduledoc false\n  use Ecto.Migration\n\n  @table_name String.to_atom(Application.compile_env(:ecto_trailer, :table_name, \"audit_log\"))\n\n  def change(table_name \\\\ @table_name) do\n    EctoTrailChangeEnum.create_type\n    create table(table_name) do\n      add :actor_id, :string, null: false\n      add :resource, :string, null: false\n      add :resource_id, :string, null: false\n      add :changeset, :map, null: false\n      add(:change_type, :change)\n\n      timestamps([type: :utc_datetime, updated_at: false])\n    end\n  end\nend\n```\n\n4. Use `EctoTrailer` in your repo:\n\n```elixir\ndefmodule MyApp.Repo do\n  use Ecto.Repo, otp_app: :my_app\n  use EctoTrailer\nend\n```\n\n5. Configure table name which is used to store audit log (in `config.ex`):\n\n```elixir\nconfig :ecto_trailer, table_name: \"audit_log\", redacted_fields: [:password, :token]\n```\n\n6. Use logging functions instead of defaults. See `EctoTrailer` module docs.","ref":"readme.html#installation-and-usage"},{"type":"extras","title":"Docs - EctoTrailer","doc":"The docs can be found at [https://hexdocs.pm/ecto_trailer](https://hexdocs.pm/ecto_trailer).","ref":"readme.html#docs"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}